/****
 * InkPane.h
 *
 *	A text edit pane for a tiny editor.
 *
 ****/


#define _H_InkPane

#include <CEditText.h>
#include "CEditDoc.h"
#include "Recognizer.h"

struct InkPane : CPanorama {
	
	List *Data;
	short SelectionRow,SelectionCol;
	CEditDoc *StatusWindow;
	short	Width,Height,NumberToTrainOn,NumberToStartOn,TrainStart,TrainEnd,TrainCmd,
			UseSamples,ReportErrors,UseHashTables,ShowPreprocessing,ConnectTheDots,
			First;

	void	IEditPane(CView *anEnclosure, CBureaucrat *aSupervisor);
	void	DoCommand(long theCommand);
	void	Draw(Rect * area);
	void	DoClick(Point hitPt,short modifierKeys,long when);
	void	UpdateMenus(void);
	void	FeatureReport(void);
	void	Test(void);
	void	DoKeyDown(char theChar, Byte keyCode, EventRecord *macEvent);
	short	CollectStroke(Point where,StrokePtr theStroke);
	void	TrainingCollectStroke(Point,long);
	short	CollectGesture(Point where,long when,short which);
	void	DrawSamples(short which,Rect *area);
	void	InvertSelection(void);
	void	DeleteEntry(void);
	void	Report(char *str);
	void	ReportCode(short code);
	void	DrawCode(short code);
	void	SetData(Handle theData);
};
